//
//  PodiumVC.swift
//  tfm
//
//  Created by Juan Angel Del Rey Sanchez on 23/5/17.
//  Copyright © 2017 Juan Angel Del Rey Sanchez. All rights reserved.
/*
 © Juan Ángel del Rey Sánchez
 Reservados todos los derechos. Está prohibido la reproducción total o parcial de esta obra por cualquier medio o procedimiento, comprendidos la impresión, la reprografía, el microfilme, el tratamiento informático o cualquier otro sistema, así como la distribución de ejemplares mediante alquiler y préstamo, sin la autorización escrita del autor o de los límites que autorice la Ley de Propiedad Intelectual.
 
 */
//

import UIKit
import Firebase
import FirebaseAuth
import FirebaseDatabase
import FBSDKLoginKit

class PodiumVC: UITableViewController {

    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    
    private var ref: FIRDatabaseReference = FIRDatabase.database().reference()
    private var listPodium = [User]()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        self.indicadorFunc()
        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
        
    }

    override func viewWillAppear(_ animated: Bool) {
        listPodium = [User]()
        cargaDatos()
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return listPodium.count
    }

    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "PodiumCell", for: indexPath) as! PodiumCell

        // Configure the cell...
        cell.oName.text = listPodium[indexPath.row].name
        cell.oPoint.text = "\(listPodium[indexPath.row].points!)"
        let url = self.listPodium[indexPath.row].url
        let nurl = URL(string: url!)
        let data = try? Data(contentsOf: nurl as! URL)
        cell.oImage.image = UIImage(data: data!)
        
        return cell
    }
    

    /*
    // Override to support conditional editing of the table view.
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            // Delete the row from the data source
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    /*
    // Override to support rearranging the table view.
    override func tableView(_ tableView: UITableView, moveRowAt fromIndexPath: IndexPath, to: IndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(_ tableView: UITableView, canMoveRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the item to be re-orderable.
        return true
    }
    */

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

    func cargaDatos(){
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.indicador.startAnimating()
        let credential = FIRFacebookAuthProvider.credential(withAccessToken: FBSDKAccessToken.current().tokenString)
        FIRAuth.auth()?.signIn(with: credential) { (user, error) in
            if let error = error { //failed due to an error
                return
            }
            
            self.ref.child("users").queryOrdered(byChild: "points").observeSingleEvent(of: .value, with: { snapshot in
                //print("\(snapshot.childrenCount)") // I got the expected number of items
                let enumerator = snapshot.children
                
                
                while let rest = enumerator.nextObject() as? FIRDataSnapshot {
                    //print(rest.value!)
                    let miuser = User()
                    let usuario = rest.value as? [ String : AnyObject]
                    //print("\(usuario?["mail"]!)")
                    
                    miuser.mail = (usuario!["mail"]! as! String)
                    miuser.name = (usuario!["name"]! as! String)
                    miuser.url = (usuario!["url"]! as! String)
                    miuser.uid = (usuario!["uid"]! as! String) 
                    miuser.points = (usuario!["points"]! as! Int)
                    
                    self.listPodium.append(miuser)
                    
                    DispatchQueue.main.async(execute: {
                        self.tableView.reloadData()
                    })
                }
                self.listPodium.reverse()
                self.tableView.reloadData()
                
                UIApplication.shared.endIgnoringInteractionEvents()
                self.indicador.stopAnimating()
                
            })
            
        }
        //end-FIRAuth

    }
    
    func indicadorFunc(){
        self.indicador.center = self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.activityIndicatorViewStyle = .whiteLarge
        self.indicador.color = UIColor.gray
        self.view.addSubview(self.indicador)
    }
    
}
