//
//  ProfileVC.swift
//  tfm
//
//  Created by Juan Angel Del Rey Sanchez on 20/5/17.
//  Copyright © 2017 Juan Angel Del Rey Sanchez. All rights reserved.
/*
 © Juan Ángel del Rey Sánchez
 Reservados todos los derechos. Está prohibido la reproducción total o parcial de esta obra por cualquier medio o procedimiento, comprendidos la impresión, la reprografía, el microfilme, el tratamiento informático o cualquier otro sistema, así como la distribución de ejemplares mediante alquiler y préstamo, sin la autorización escrita del autor o de los límites que autorice la Ley de Propiedad Intelectual.
 
 */
//
import UIKit
import Foundation

import Firebase
import FirebaseAuth
import FirebaseDatabase
import FirebaseStorage
import FBSDKLoginKit
import FBSDKShareKit

class ProfileVC: UIViewController, FBSDKLoginButtonDelegate {
    
    
    @IBOutlet weak var oImage: UIImageView!
    @IBOutlet weak var oName: UILabel!
    @IBOutlet weak var oMail: UILabel!
    @IBOutlet weak var oPoints: UILabel!
    
    private var sNombre: String = ""
    private var sMail: String = ""
    private var sUID: String = ""
    private var iPoint: Int = 0
    private var sURL:String = ""
    
    private var ref: FIRDatabaseReference = FIRDatabase.database().reference()
    private var usersRef: FIRDatabaseReference!
    private lazy var messageRef: FIRDatabaseReference = self.ref.child("messages")
    private var newMessageRefHandle: FIRDatabaseHandle?
    
    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    //private var isIndicator:Bool = false
    
    private var credential: FIRAuthCredential?
    var cuentaBorrada: Bool = false
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        // [START configure_firebase]
        //FIRApp.configure()

        // [END configure_firebase]
        
        // Config indicator.
        self.indicadorFunc()
        self.cuentaBorrada = false
        
        //Get credential
        self.credential = FIRFacebookAuthProvider.credential(withAccessToken: FBSDKAccessToken.current().tokenString)
        //print ("--->Credencial:\(self.credential)")
        
        //Configure delegate
        let loginButton = FBSDKLoginButton()
        
        loginButton.delegate = self
        
        // button in screen
        let setX = self.view.frame.width / 2
        let setY = self.view.frame.height - (tabBarController?.tabBar.frame.height)! - (loginButton.frame.height/2) - 4
        let point = CGPoint(x: setX, y: setY)

        loginButton.center = point //self.view.center
        self.view.addSubview(loginButton)
        
        let shareApp = FBSDKShareLinkContent()
        
        //shareApp.contentURL = NSURL(string: "") as! URL
        shareApp.contentURL = URL(string: "https://itunes.apple.com/es/app/apple-store/id375380948?mt=8")
        
        //button in screen
        //let setX2 = self.view.frame.width / 2
        let setY2 = setY - 35
        let point2 = CGPoint(x: setX, y: setY2)
        
        let shareButton = FBSDKShareButton()
        shareButton.shareContent = shareApp
        shareButton.frame = loginButton.frame
        shareButton.center = point2
        //print("\(shareButton.frame.width),\(shareButton.frame.height)")
        //shareApp. = point2 //self.view.center
        self.view.addSubview(shareButton)
        
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override func viewWillAppear(_ animated: Bool) {

        self.cargarDatos()
    }
    
    func cargarDatos() {
        //Indicator
        //self.isIndicator = true
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.indicador.startAnimating()
        //Firebase authentication
        //print("--->AUTENTICACION FIREBASE")
        if self.credential == nil {
            //print("--->nula")
        }
        else{
            //print("--->no nula")
        }
        FIRAuth.auth()?.signIn(with: self.credential!) { (user, error) in
            if let error = error { //failed due to an error
                //print("--->0")
                return
            }
            //Get user information from FB
            //print("--->1")
            
            //print("--->mail:\(user?.email)")
            
            self.sUID = (user?.uid)! //the firebase uid
            //self.sMail = (user?.email)!
            self.sMail = ""
            self.sNombre = (user?.displayName)!
            //print("--->UID:\(self.sUID)")
            
            let url = (user?.photoURL!)!
            self.sURL = "\(url)"
            
            let data = try? Data(contentsOf: (user?.photoURL as! URL))
            
            //set values outlets
            self.oName.text = self.sNombre
            self.oMail.text = self.sMail
            self.oImage.image = UIImage(data: data!)
            
            self.usersRef = self.ref.child("users").child(self.sUID)
            
            //Get information
            self.ref.child("users").child(self.sUID).observeSingleEvent(of: .value, with: { (snapshot) in
                if (snapshot.exists()){
                    //print("Existe")
                    let value = snapshot.value as? NSDictionary
                    //Get puntos from user
                    self.iPoint = value?["points"] as! Int
                    //print("--->puntos:\(self.iPoint)")
                    self.oPoints.text = "\(self.iPoint)"
                    //update user information
                    let user = [   "name": self.sNombre,
                                   "mail": self.sMail,
                                   "uid": self.sUID,
                                   "points": self.iPoint,
                                   "url": self.sURL] as [String : Any]
                    let key = self.ref.child("users").child(self.sUID).updateChildValues(user)
                    
                }
                else{
                    //Sign up
                    //print("--->Es nulo")
                    //let keyFirebase = self.ref.child("users").child(self.sUID).setValue(self.sUID)
                    
                    //let keyFirebase = self.ref.child("users").
                    let user = [   "name": self.sNombre,
                                   "mail": self.sMail,
                                   "uid": self.sUID,
                                   "points": 0,
                                   "url": self.sURL] as [String : Any]
                    let key = self.ref.child("users").child(self.sUID).setValue(user)
                    DispatchQueue.main.async(execute: {
                        self.oPoints.text = "\(self.iPoint)"
                    })
                }
                
            }){ (error) in print(error.localizedDescription)
                
            }
            
            UIApplication.shared.endIgnoringInteractionEvents()
            self.indicador.stopAnimating()
            
        }
    }
    
    func loginButton(_ loginButton: FBSDKLoginButton!, didCompleteWith result: FBSDKLoginManagerLoginResult!, error: Error?) {
        //Nothing here
        if let error = error {
            print(error.localizedDescription)
            return
        }
        else if result.isCancelled {
            // Handle cancellations
        }
        else {
            //Nothing here
            //print("Nothing")
        }
    }
    
    
    func loginButtonDidLogOut(_ loginButton: FBSDKLoginButton!) {
        //print("User Logged Out")
        // Log out -> Go to Login Screen
        try! FIRAuth.auth()!.signOut()
        self.performSegue(withIdentifier: "unwindLogin", sender: nil)
    }
    
    @IBAction func bBaja(_ sender: Any) {
        var arrRef = [FIRDatabaseReference]()
        
        let alertController = UIAlertController(title: "Borrar Cuenta de Usuario", message: "Se va a proceder a borrar\ntodos sus datos del sistema\n¿Está seguro?", preferredStyle: .alert)
        
        let actionYes = UIAlertAction(title: "Yes", style: .default) { (action:UIAlertAction) in
            //Delete user
            self.cuentaBorrada = true

            FIRAuth.auth()?.signIn(with: self.credential!) { (user, error) in
                if let error = error { //failed due to an error
                    return
                }
                //print ("\(self.sUID)")
                self.ref.child("users").child(self.sUID).ref.removeValue()

                self.messageRef.observeSingleEvent(of: .value, with: { (snapshot) -> Void in
                    if snapshot.exists() {
                        let message = snapshot.children
                        
                        //Delete Photos
                        
                        while let mess = message.nextObject() as? FIRDataSnapshot {
                            // print("--->\(mess.ref)") --> lo que hay que borrar
                            let messData = mess.value as! Dictionary<String, String>
                            if let id = messData["senderId"] as String!, let name = messData["senderName"] as String!, let text = messData["text"] as String!, text.characters.count > 0 {
                                
                                if id == self.sUID {
                                    //mess.ref.removeValue()
                                    arrRef.append(mess.ref)
                                }
                                
                            } else if let id = messData["senderId"] as String!,
                                let photoURL = messData["photoURL"] as String! {
                                if id == self.sUID {
                                    //Delete photos
                                    let storage = FIRStorage.storage()
                                    
                                    let urlFile = photoURL
                                    let refPhoto = storage.reference(forURL: urlFile)
                                    
                                    
                                    //Delete Messages
                                    //mess.ref.removeValue()
                                    arrRef.append(mess.ref)
                                    //Delete Photo
                                    refPhoto.delete(completion: {(error) -> Void in
                                        if (error != nil) {
                                            // Uh-oh, an error occurred!
                                            print ("\(error)")
                                        } else {
                                            // File deleted successfully
                                            //print("--->Archivo borrado: \(refPhoto)")
                                        }
                                    })
                                }
                                
                            } else {
                                print("Error!")
                            }
                        }
                        for referencia in arrRef {
                            let r = referencia
                            //print("--->Elimino:\(r)")
                            r.removeValue()
                        }
                        arrRef.removeAll()
                        
                    }
                })
                
                
                /*
                 DispatchQueue.main.async(execute: {
                 // Log out -> Go to Login Screen
                 
                 })
 */

                try! FIRAuth.auth()!.signOut()
                self.performSegue(withIdentifier: "unwindLogin", sender: nil)
            }
        }
        
        let actionNo = UIAlertAction(title: "No", style: .default) { (action:UIAlertAction) in
            //Nothing
            print("You've pressed No button");
        }
        
        alertController.addAction(actionYes)
        alertController.addAction(actionNo)
        self.present(alertController, animated: true, completion:nil)
        

    }
    
    func indicadorFunc(){
        self.indicador.center = self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.activityIndicatorViewStyle = .whiteLarge
        self.indicador.color = UIColor.gray
        self.view.addSubview(self.indicador)
    }
    
}

