//
//  PuntosLimpiosVC.swift
//  tfm
//
//  Created by Juan Angel Del Rey Sanchez on 27/5/17.
//  Copyright © 2017 Juan Angel Del Rey Sanchez. All rights reserved.
/*
 © Juan Ángel del Rey Sánchez
 Reservados todos los derechos. Está prohibido la reproducción total o parcial de esta obra por cualquier medio o procedimiento, comprendidos la impresión, la reprografía, el microfilme, el tratamiento informático o cualquier otro sistema, así como la distribución de ejemplares mediante alquiler y préstamo, sin la autorización escrita del autor o de los límites que autorice la Ley de Propiedad Intelectual.
 
 */
//

import UIKit
import MapKit

class PuntosLimpiosVC: UIViewController, MKMapViewDelegate {

    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    @IBOutlet weak var oMap: MKMapView!
    
    //URL Situación Puntos limpios (ALCOBENDAS)
    let urlStringPuntosLimpios = "http://datos.alcobendas.org/dataset/523d25bb-2461-49cd-b720-6ece9fa6fce7/resource/3d01fb34-4624-443d-a4ed-a45b379b30bb/download/ubicacion-punto-limpio-movilfecha-adaaptada.json"
    
    private var arrPuntosLimpios = [PuntoLimpio]()
    var m_locationManager:CLLocationManager?
    //var m_map:MKMapView?
    let latMun = 40.5361528
    let lonMun = -3.6291320
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        self.indicadorFunc()
        
        self.oMap?.delegate = self
        
        self.oMap?.mapType = MKMapType.standard
        self.oMap?.isZoomEnabled = true
        self.oMap?.isScrollEnabled = true
        
        self.cargaDatosPuntos()
        
        
        /*
        self.m_locationManager = CLLocationManager()
        self.m_locationManager?.delegate = self
        self.m_locationManager?.allowsBackgroundLocationUpdates = true
        self.m_locationManager?.desiredAccuracy = kCLLocationAccuracyBest
        
        let status:CLAuthorizationStatus = CLLocationManager.authorizationStatus()
        
        if (status == CLAuthorizationStatus.notDetermined){
            self.m_locationManager?.requestWhenInUseAuthorization()
        }
        else{
            self.m_locationManager?.startUpdatingLocation()
            self.oMap?.showsUserLocation = true
            let regionRadius: CLLocationDistance = 2500
            let coordinateRegion = MKCoordinateRegionMakeWithDistance((self.m_locationManager?.location?.coordinate)!,
                                                                      regionRadius * 2.0, regionRadius * 2.0)
            self.oMap?.setRegion(coordinateRegion, animated: true)
        }
        //Empezamos la localizacion
        self.m_locationManager?.startUpdatingLocation()
        */
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func cargaDatosPuntos(){
        var nulo: Bool = false
        
        let url = URL(string: urlStringPuntosLimpios)
        
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.indicador.startAnimating()
        
        URLSession.shared.dataTask(with:url!) { (data, response, error) in
            if error != nil {
                print(error)
            } else {
                do {
                    
                    if let parsedData = try JSONSerialization.jsonObject(with: data!, options: []) as? [Any] {
                        for object in parsedData {
                            nulo = false
                            // access all objects in array
                            let e = object as? [String: Any]
                            //print ("--->\((e?["Desde"])!)")
                            //print ("--->\((e?["Hasta"])!)")
                            //print ("--->\((e?["Ubicación"])!)")
                            //print ("--->\((e?["lat"])!)")
                            //print ("--->\((e?["lon"])!)")
                            
                            let punto = PuntoLimpio(desde: (e?["Desde"])! as! String, hasta: (e?["Hasta"])! as! String, ubicacion: (e?["Ubicación"])! as! String, latitude: (e?["lat"])! as! Double, longitude: (e?["lon"])! as! Double)
                            self.arrPuntosLimpios.append(punto)
                            
                            let lat = (e?["lat"])!
                            let lon = (e?["lon"])!
                            let ubicacion = (e?["Ubicación"])!
                            let titulo = "Punto Limpio"
                            let desde = (e?["Desde"])!
                            let hasta = (e?["Hasta"])!
                            let subtitulo = "\(desde)-\(hasta)"
                            
                            var annotation:MKMyPointAnnotation = MKMyPointAnnotation(coordinate: CLLocationCoordinate2D(latitude: lat as! CLLocationDegrees,longitude: lon as! CLLocationDegrees), title: titulo , subtitle: subtitulo as! String, desde: "", hasta: "", id: "")
                            
                            self.oMap?.addAnnotation(annotation)
                            
                            //print ("--->")
                            
                        }
                        
                        DispatchQueue.main.async(execute: {
                            //print("--->Contador:\(self.arrPuntosLimpios.count)")
                            let span = MKCoordinateSpan(latitudeDelta: 0.09, longitudeDelta: 0.09)
                            let location = CLLocationCoordinate2D(latitude: self.latMun, longitude: self.lonMun)
                            let region = MKCoordinateRegion(center: location ,span: span)
                            self.oMap?.setRegion(region,animated: true)
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                        })
                        
                    }
                } catch let error as NSError {
                    print(error)
                }
            }
            
            }.resume()
    }
    
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */
    
    func mapView(_ mapView: MKMapView, viewFor annotation: MKAnnotation) -> MKAnnotationView?
    {
        
        if  let annotation = annotation as? MKMyPointAnnotation
        {
            //let current_loc:CLLocation  = self.m_locationManager!.location!
            //let obj_loc:CLLocation = CLLocation(latitude: annotation.coordinate.latitude,longitude: annotation.coordinate.longitude)
            //let distance:CLLocationDistance = (current_loc.distance(from: obj_loc))
            //var distancia:Double = Double(distance)
            //annotation.subtitle = "distance: " + String(format:"%.2f", distance)
            
            let identifier = "CustomPinAnnotationView"
            var pinView: MKPinAnnotationView
            
            if let dequeuedView = self.oMap?.dequeueReusableAnnotationView(withIdentifier: identifier)
                as? MKPinAnnotationView {
                dequeuedView.annotation = annotation
                //dequeuedView.image = UIImage(named: "punto-limpio")
                pinView = dequeuedView
                //print("--->1")
            } else {
                
                pinView = MKPinAnnotationView(annotation: annotation, reuseIdentifier: identifier)
                pinView.canShowCallout = true
                //
                pinView.image  = UIImage(named: "pin-punto-limpio")
                var frame:CGRect = pinView.frame
                frame.size.width = 50
                frame.size.height = 50
                pinView.frame = frame
                
                pinView.calloutOffset = CGPoint(x: -5, y: 5)
                //pinView.rightCalloutAccessoryView = UIButton(type:.detailDisclosure) as UIView
                pinView.rightCalloutAccessoryView = UIImageView(image: UIImage(named: "punto-limpio-icono"))
                //UIButton(type:.detailDisclosure) as UIView
                //print("--->2")
                pinView.setSelected(true,animated: true)
            }
            
            return pinView
        }
        return nil
    }
    
    func indicadorFunc(){
        self.indicador.center = self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.activityIndicatorViewStyle = .whiteLarge
        self.indicador.color = UIColor.gray
        self.view.addSubview(self.indicador)
    }
}
