//
//  RecogidaVC.swift
//  tfm
//
//  Created by Juan Angel Del Rey Sanchez on 27/5/17.
//  Copyright © 2017 Juan Angel Del Rey Sanchez. All rights reserved.
/*
 © Juan Ángel del Rey Sánchez
 Reservados todos los derechos. Está prohibido la reproducción total o parcial de esta obra por cualquier medio o procedimiento, comprendidos la impresión, la reprografía, el microfilme, el tratamiento informático o cualquier otro sistema, así como la distribución de ejemplares mediante alquiler y préstamo, sin la autorización escrita del autor o de los límites que autorice la Ley de Propiedad Intelectual.
 
 */
//

import UIKit

class RecogidaVC: UITableViewController {

    //URL cantidad de residuos recogidos (ALCOBENDAS)
    let urlString = "http://datos.alcobendas.org/dataset/8efb362f-44fa-4339-9c5e-bfcd0ba64274/resource/c0a6371a-8a79-421f-8d9d-bacdc7c5888f/download/recogida-residuos-2017adaptado-incluye-punto-limpio.json"
    
    private var arrResiduos = [Residuos]()
    private var indicador: UIActivityIndicatorView = UIActivityIndicatorView()
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        self.indicadorFunc()
        
        self.cargaDatosReciclados()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func cargaDatosReciclados(){
        var nulo: Bool = false
        
        let url = URL(string: urlString)
        UIApplication.shared.beginIgnoringInteractionEvents()
        self.indicador.startAnimating()
        URLSession.shared.dataTask(with:url!) { (data, response, error) in
            if error != nil {
                print(error)
            } else {
                do {
                    /*
                     if let array = jsonWithArrayRoot as? [Any] {
                     if let firstObject = array.first {
                     // access individual object in array
                     }
                     
                     for object in array {
                     // access all objects in array
                     }
                     
                     for case let string as String in array {
                     // access only string values in array
                     }
                     }*/
                    
                    if let parsedData = try JSONSerialization.jsonObject(with: data!, options: []) as? [Any] {
                        for object in parsedData {
                            nulo = false
                            // access all objects in array
                            let e = object as? [String: Any]
                            //print ("--->\((e?["Año"])!)")
                            //print ("--->\((e?["Mes"])!)")
                            //print ("--->\((e?["Residuo"])!)")
                            //print ("--->\((e?["Modalidad"])!)")
                            //var cantidad: Int = 0
                            if self.nullToNil(value: (e?["Cantidad"])! as AnyObject) != nil {
                                //print("--->\((e?["Cantidad"])!)")
                                let resid = Residuos(año: (e?["Año"])! as! Int, mes: (e?["Mes"])! as! String, residuo: (e?["Residuo"])! as! String, modalidad: (e?["Modalidad"])! as! String, cantidad: (e?["Cantidad"])! as! Int)
                                self.arrResiduos.append(resid)
                            }
                            else
                            {
                                //print("--->0. NULO")
                                let resid = Residuos(año: (e?["Año"])! as! Int, mes: (e?["Mes"])! as! String, residuo: (e?["Residuo"])! as! String, modalidad: (e?["Modalidad"])! as! String, cantidad: 0)
                                self.arrResiduos.append(resid)
                            }
                            
                            //print ("--->")
                            
                        }
                        //print("--->Contador:\(self.arrResiduos.count)")
                        //print("--->\((self.arrResiduos[self.arrResiduos.count - 1].residuo)!),\((self.arrResiduos[self.arrResiduos.count - 1].cantidad)!)")
                        DispatchQueue.main.async(execute: {
                            self.tableView.reloadData()
                            UIApplication.shared.endIgnoringInteractionEvents()
                            self.indicador.stopAnimating()
                        })
                    }
                } catch let error as NSError {
                    print(error)
                }
            }
            
            }.resume()
    }
    
    func nullToNil(value : AnyObject?) -> AnyObject? {
        if value is NSNull {
            return nil
        } else {
            return value
        }
    }

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */
    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }
    
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return arrResiduos.count
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "RecogidaCell", for: indexPath) as! RecogidaCell
        
        // Configure the cell...
        
        cell.oFecha.text = "\((arrResiduos[indexPath.row].año)!) : \((arrResiduos[indexPath.row].mes)!)"
        cell.oCantidad.text = "\(arrResiduos[indexPath.row].cantidad!)"
        cell.oResiduo.text = arrResiduos[indexPath.row].residuo
        
        return cell
    }
    
    func indicadorFunc(){
        self.indicador.center = self.view.center
        self.indicador.autoresizingMask = [.flexibleBottomMargin, .flexibleLeftMargin, .flexibleWidth, .flexibleRightMargin, .flexibleTopMargin, .flexibleHeight, .flexibleBottomMargin]
        self.indicador.hidesWhenStopped = true
        self.indicador.activityIndicatorViewStyle = .whiteLarge
        self.indicador.color = UIColor.gray
        self.view.addSubview(self.indicador)
    }
}
