//
//  SignupVC.swift
//  tfm
//
//  Created by Juan Angel Del Rey Sanchez on 21/5/17.
//  Copyright © 2017 Juan Angel Del Rey Sanchez. All rights reserved.
/*
 © Juan Ángel del Rey Sánchez
 Reservados todos los derechos. Está prohibido la reproducción total o parcial de esta obra por cualquier medio o procedimiento, comprendidos la impresión, la reprografía, el microfilme, el tratamiento informático o cualquier otro sistema, así como la distribución de ejemplares mediante alquiler y préstamo, sin la autorización escrita del autor o de los límites que autorice la Ley de Propiedad Intelectual.
 
 */
//

import UIKit
import Foundation

import Firebase
import FirebaseAuth
import FBSDKLoginKit

class SignupVC: UIViewController, FBSDKLoginButtonDelegate {
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        // [START configure_firebase]
        //FIRApp.configure()
        // [END configure_firebase]
        
        //Get credential
        let credential = FIRFacebookAuthProvider.credential(withAccessToken: FBSDKAccessToken.current().tokenString)
        
        //Firebase authentication
        FIRAuth.auth()?.signIn(with: credential) { (user, error) in
            if let error = error { //failed due to an error
                return
            }
            let uid = user?.uid //the firebase uid
            print ("--->uid:" + uid!)
        }
        
        //Configure delegate
        let loginButton = FBSDKLoginButton()
        loginButton.delegate = self
        
        // button in screen
        let setX = self.view.frame.width / 2
        let setY = self.view.frame.height - (tabBarController?.tabBar.frame.height)! - loginButton.frame.height - 5
        //print("1:\(setY),2:\(self.view.frame.height),3:\((tabBarController?.tabBar.frame.height)!),4:\(loginButton.frame.height),")
        let point = CGPoint(x: setX, y: setY)
        
        loginButton.center = point //self.view.center
        self.view.addSubview(loginButton)
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    func loginButton(_ loginButton: FBSDKLoginButton!, didCompleteWith result: FBSDKLoginManagerLoginResult!, error: Error?) {
        //Nothing here
        if let error = error {
            print(error.localizedDescription)
            return
        }
        else if result.isCancelled {
            // Handle cancellations
        }
        else {
            //Nothing here
            //print("Nothing")
        }
    }
    
    
    func loginButtonDidLogOut(_ loginButton: FBSDKLoginButton!) {
        print("User Logged Out")
        // Log out -> Go to Login Screen
        try! FIRAuth.auth()!.signOut()
        self.performSegue(withIdentifier: "unwindLogin", sender: nil)
    }
}
