//
//  ViewController.swift
//  tfm
//
//  Created by Juan Angel Del Rey Sanchez on 12/5/17.
//  Copyright © 2017 Juan Angel Del Rey Sanchez. All rights reserved.
/*
 © Juan Ángel del Rey Sánchez
 Reservados todos los derechos. Está prohibido la reproducción total o parcial de esta obra por cualquier medio o procedimiento, comprendidos la impresión, la reprografía, el microfilme, el tratamiento informático o cualquier otro sistema, así como la distribución de ejemplares mediante alquiler y préstamo, sin la autorización escrita del autor o de los límites que autorice la Ley de Propiedad Intelectual.

 */
//

import UIKit
//import Firebase
//import FirebaseAuth
import FBSDKLoginKit

class ViewController: UIViewController, FBSDKLoginButtonDelegate {

    private var logarse: Bool = true
// --------------------------------------------------
    override func viewDidAppear(_ animated: Bool) {
        
        if(FBSDKAccessToken.current() != nil){
            //print("hay token")
            
            self.performSegue(withIdentifier: "sgLogin", sender: self)
        }
        else {
            //print("NO hay token")
        }
    }
// --------------------------------------------------
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        
        //Configure delegate
        let loginButton = FBSDKLoginButton()
        loginButton.readPermissions = ["email"]
        loginButton.delegate = self
        
        loginButton.center = self.view.center
        self.view.addSubview(loginButton)
     

    }
// --------------------------------------------------
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
// --------------------------------------------------
    //unwind
    @IBAction func returnActionForSegue(segue: UIStoryboardSegue) {
        //do useful actions here
        //If back from UseConditions
        if segue.source .isKind(of: UseconditionsVC.self) {
            var miView = segue.source as! UseconditionsVC
            if (miView.conditions) {
                //print("--->ACEPTADA")
            }
            else{
                //print("--->RECHAZADA")
                exit(0)
                //Salimos de la aplicacion
            }
        } else if segue.source .isKind(of: ProfileVC.self) {
            var miProfile = segue.source as! ProfileVC
            if ( miProfile.cuentaBorrada ){
                FBSDKAccessToken.setCurrent(nil)
            }
        }
    }
// --------------------------------------------------
    func loginButton(_ loginButton: FBSDKLoginButton!, didCompleteWith result: FBSDKLoginManagerLoginResult!, error: Error?) {
        if let error = error {
            print("--->ERROR:\(error.localizedDescription)")
            return
        }
        else if result.isCancelled {
            // Handle cancellations
            
        }
        else {
            //print("OK - vamos a la siguiente pantalla")
            if result.grantedPermissions.contains("email") {
                //print("--->SI lo contiene")
                //print("--->Email:\(result.value(forKey: "email"))")
            }
            else{
                //print("--->no lo contiene")
            }
            self.performSegue(withIdentifier: "sgLogin", sender: self)
        }
    }

// --------------------------------------------------
    func loginButtonDidLogOut(_ loginButton: FBSDKLoginButton!) {
        //print("User Logged Out")
    }
// --------------------------------------------------
    
    // No utilizamos la siguiente funcion
    /*
    @IBAction func facebookLogin(sender: UIButton) {
        let fbLoginManager = FBSDKLoginManager()
        fbLoginManager.logIn(withReadPermissions: ["public_profile", "email"], from: self) { (result, error) in
            if let error = error {
                print("Failed to login: \(error.localizedDescription)")
                return
            }
            
            guard let accessToken = FBSDKAccessToken.current() else {
                print("Failed to get access token")
                return
            }
            
            let credential = FIRFacebookAuthProvider.credential(withAccessToken: accessToken.tokenString)
            
            // Perform login by calling Firebase APIs
            FIRAuth.auth()?.signIn(with: credential, completion: { (user, error) in
                if let error = error {
                    print("Login error: \(error.localizedDescription)")
                    let alertController = UIAlertController(title: "Login Error", message: error.localizedDescription, preferredStyle: .alert)
                    let okayAction = UIAlertAction(title: "OK", style: .cancel, handler: nil)
                    alertController.addAction(okayAction)
                    self.present(alertController, animated: true, completion: nil)
                    
                    return
                }
                
                // Present the main view
                if let viewController = self.storyboard?.instantiateViewController(withIdentifier: "MainView") {
                    UIApplication.shared.keyWindow?.rootViewController = viewController
                    self.dismiss(animated: true, completion: nil)
                }
                
            })
            
        }   
    }
    */
}

